module cam_top(
	sys_clk,
	sys_rst_n,
	key1,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	cam_rst_n,
	cam_pwdn,
	cam_scl,
	img_data_en,
	img_y,
	img_cb,
	img_cr,
	bw_fs_data,
	cam_sda);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input key1;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	output cam_rst_n;
	output cam_pwdn;
	output cam_scl;
	output img_data_en;
	output [7:0] img_y;
	output [7:0] img_cb;
	output [7:0] img_cr;
	output [15:0] bw_fs_data;
	inout cam_sda;

	wire sys_clk;
	wire sys_rst_n;
	wire key1;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	reg cam_rst_n;
	reg cam_pwdn;
	wire cam_scl;
	wire img_data_en;
	wire [7:0] img_y;
	wire [7:0] img_cb;
	wire [7:0] img_cr;
	wire [15:0] bw_fs_data;
	wire cam_sda;
	wire coms_capture_data1_cmos_frame_vsync;
	wire coms_capture_data1_cmos_frame_href;
	wire coms_capture_data1_cmos_frame_valid;
	wire i2c_ov560_cfg3_i2c_exec;
	wire i2c_ov560_cfg3_i2c_rh_wl;
	wire [23:0] i2c_ov560_cfg3_i2c_data;
	wire [7:0] i2c_dri2_i2c_data_r;
	wire i2c_dri2_i2c_done;
	wire i2c_dri2_dri_clk;
	wire i2c_ov560_cfg3_init_done;
	assign sys_rst_n = i2c_ov560_cfg3_init_done;
	assign img_data_en = coms_capture_data1_cmos_frame_valid;

	//----Code starts here: integrated by Robei-----
	
	parameter  H_CMOS_DISP = 13'd480;                  //CMOSֱ--
	parameter  V_CMOS_DISP = 13'd272;                  //CMOSֱ--	
	parameter  TOTAL_H_PIXEL = 13'd1800;  //ˮƽشСH_CMOS_DISP 
	parameter  TOTAL_V_PIXEL = 13'd1000;  //ֱشСV_CMOS_DISP 
	
	parameter SLAVE_ADDR = 7'h3c          ; //OV5640ַ7'h3c
	parameter BIT_CTRL   = 1'b1           ; //OV5640ֽڵַΪ16λ  0:8λ 1:16λ
	parameter CLK_FREQ   = 27'd50_000_000 ; //i2c_driģʱƵ 
	parameter I2C_FREQ   = 18'd250_000    ; //I2CSCLʱƵ,400KHz
	
	//wire define
	wire            rst_n           ; 
	wire            i2c_dri_clk     ;   //I2Cʱ
	wire            i2c_done        ;   //I2Cдź
	wire   [7:0]    i2c_data_r      ;   //I2C
	wire            i2c_exec        ;   //I2Cź
	wire   [23:0]   i2c_data        ;   //I2Cдַ+
	wire            i2c_rh_wl       ;   //I2Cдź
	wire            cam_init_done   ;   //ͷʼź 
	wire            cmos_frame_vsync;   //֡Чͬź   
	wire            cmos_frame_href ;
	wire   [15:0]   img_data        ;   //ͷͼЧ
	wire            transfer_flag   ;   //ͼʼ־,0:ʼ 1:ֹͣ
	
	//*****************************************************//
	//**                    main code
	//*****************************************************//
	
	assign  rst_n = sys_rst_n ;
	//Դģʽѡ 0ģʽ 1Դģʽ
	always @ (posedge sys_clk) begin
	 cam_pwdn  <= 1'b0;
	cam_rst_n <= 1'b1;
	end
	 
	
	//I2Cģ    
	i2c_ov560_cfg u_i2c_ov560_cfg (
	    .clk           (i2c_dri_clk),
	    .rst_n         (rst_n),
	    .key1          (key1),
	    .i2c_done      (i2c_done),
	    .i2c_data_r    (i2c_data_r),
	    .cmos_h_pixel  (H_CMOS_DISP),
	    .cmos_v_pixel  (V_CMOS_DISP),
	    .total_h_pixel (TOTAL_H_PIXEL),
	    .total_v_pixel (TOTAL_V_PIXEL),    
	    .i2c_exec      (i2c_exec),
	    .i2c_data      (i2c_data),
	    .i2c_rh_wl     (i2c_rh_wl),
	    .init_done     (cam_init_done)
	    );    
	
	//I2Cģ
	i2c_dri 
	   #(
	    .SLAVE_ADDR  (SLAVE_ADDR),               //
	    .CLK_FREQ    (CLK_FREQ  ),              
	    .I2C_FREQ    (I2C_FREQ  )                
	    ) 
	   u_i2c_dri (
	    .clk         (sys_clk   ),   
	    .rst_n       (rst_n     ),   
	    //i2c interface
	    .i2c_exec    (i2c_exec  ),   
	    .bit_ctrl    (BIT_CTRL  ),   
	    .i2c_rh_wl   (i2c_rh_wl ),   
	    .i2c_addr    (i2c_data[23:8]),   
	    .i2c_data_w  (i2c_data[7:0]),   
	    .i2c_data_r  (i2c_data_r),   
	    .i2c_done    (i2c_done  ),  
	    .i2c_ack     (), 
	    .scl         (cam_scl   ),   
	    .sda         (cam_sda   ),   
	    //user interface
	    .dri_clk     (i2c_dri_clk)               //I2Cʱ
	);
	
	//ͷݲɼģ
	coms_capture_data u_coms_capture_data (
	    .rst_n              (rst_n & cam_init_done),
	    .cam_pclk           (cam_pclk),   
	    .cam_vsync          (cam_vsync),
	    .cam_href           (cam_href),
	    .cam_data           (cam_data),  
	             
	    .cmos_frame_vsync   (cmos_frame_vsync),
	    .cmos_frame_href    (cmos_frame_href),
	    .cmos_frame_valid   (img_data_en),     
	    .cmos_frame_data    (img_data)             
	    );
	//ͷͼֱģ
	picture_size u_picture_size (
		.clk                (sys_clk  ),		//clk_50m_lcd
		.rst_n              (sys_rst_n         ),                       
		.cmos_h_pixel       ( ),   //ͷˮƽֱ 
		.cmos_v_pixel       ( ),   //ͷֱֱ  
		.total_h_pixel      ( ),   //HTSĴ
		.total_v_pixel      ( )    //VTSĴ
		);
		
	//RGBתYCbCrģ
	 rgb2ycbcr u_rgb2ycbcr (
	     //module clock
	     .clk             (cam_pclk),            // ʱź
	     .rst_n           (rst_n  ),            // λźţЧ
	     //ͼǰݽӿ
	     .pre_frame_vsync (cmos_frame_vsync),    // vsyncź
	     .pre_frame_hsync (cmos_frame_href),    // hrefź
	     .pre_frame_de    (img_data_en   ),    // data enableź
	     .img_red         (img_data[15:11] ),
	     .img_green       (img_data[10:5 ] ),
	     .img_blue        (img_data[ 4:0 ] ),
	     //ͼݽӿ
	     .post_frame_vsync (),   // vsyncź
	     .post_frame_hsync (),   // hrefź
	     .post_frame_de   (post_frame_de),      // data enableź
	     .img_y           (img_y),
	     .img_cb          (img_cb),
	     .img_cr          (img_cr),
		 .bw_fs_data	  (bw_fs_data)
	 );	
	
	
	//---Module instantiation---
	coms_capture_data coms_capture_data1(
		.rst_n(i2c_ov560_cfg3_init_done),
		.cam_pclk(cam_pclk),
		.cam_vsync(cam_vsync),
		.cam_href(cam_href),
		.cam_data(cam_data),
		.cmos_frame_vsync(coms_capture_data1_cmos_frame_vsync),
		.cmos_frame_href(coms_capture_data1_cmos_frame_href),
		.cmos_frame_valid(coms_capture_data1_cmos_frame_valid));

	i2c_dri i2c_dri2(
		.clk(sys_clk),
		.rst_n(sys_rst_n),
		.i2c_exec(i2c_ov560_cfg3_i2c_exec),
		.i2c_rh_wl(i2c_ov560_cfg3_i2c_rh_wl),
		.i2c_addr(i2c_ov560_cfg3_i2c_data),
		.i2c_data_w(i2c_ov560_cfg3_i2c_data),
		.i2c_data_r(i2c_dri2_i2c_data_r),
		.i2c_done(i2c_dri2_i2c_done),
		.scl(cam_scl),
		.sda(cam_sda),
		.dri_clk(i2c_dri2_dri_clk));

	i2c_ov560_cfg i2c_ov560_cfg3(
		.clk(i2c_dri2_dri_clk),
		.rst_n(sys_rst_n),
		.key1(key1),
		.i2c_data_r(i2c_dri2_i2c_data_r),
		.i2c_done(i2c_dri2_i2c_done),
		.i2c_exec(i2c_ov560_cfg3_i2c_exec),
		.i2c_data(i2c_ov560_cfg3_i2c_data),
		.i2c_rh_wl(i2c_ov560_cfg3_i2c_rh_wl),
		.init_done(i2c_ov560_cfg3_init_done));

	picture_size picture_size4(
		.rst_n(sys_rst_n),
		.clk(sys_clk));

	rgb2ycbcr rgb2ycbcr5(
		.clk(cam_pclk),
		.rst_n(sys_rst_n),
		.pre_frame_vsync(coms_capture_data1_cmos_frame_vsync),
		.pre_frame_hsync(coms_capture_data1_cmos_frame_href),
		.pre_frame_de(coms_capture_data1_cmos_frame_valid),
		.img_y(img_y),
		.img_cb(img_cb),
		.img_cr(img_cr),
		.bw_fs_data(bw_fs_data));

endmodule    //cam_top

