module coms_capture_data(
	rst_n,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	cmos_frame_vsync,
	cmos_frame_href,
	cmos_frame_valid,
	cmos_frame_data);

	//---Ports declearation: generated by Robei---
	input rst_n;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	output cmos_frame_vsync;
	output cmos_frame_href;
	output cmos_frame_valid;
	output [15:0] cmos_frame_data;

	wire rst_n;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	wire cmos_frame_vsync;
	wire cmos_frame_href;
	wire cmos_frame_valid;
	wire [15:0] cmos_frame_data;

	//----Code starts here: integrated by Robei-----
	
	//Ĵȫɺȵȴ10֡
	//ĴЧٿʼɼͼ
	parameter  WAIT_FRAME = 4'd10    ;            //Ĵȶȴ֡            
								     
	//reg define                     
	reg             cam_vsync_d0     ;
	reg             cam_vsync_d1     ;
	reg             cam_href_d0      ;
	reg             cam_href_d1      ;
	reg    [3:0]    cmos_ps_cnt      ;            //ȴ֡ȶ
	reg    [7:0]    cam_data_d0      ;            
	reg    [15:0]   cmos_data_t      ;            //8λת16λʱĴ
	reg             byte_flag        ;            //16λRGBתɵı־ź
	reg             byte_flag_d0     ;
	reg             frame_val_flag   ;            //֡Чı־ 
	
	wire            pos_vsync        ;            //볡ͬźŵ
	
	//*****************************************************//
	//**                    main code
	//*****************************************************//
	
	//볡ͬźŵ
	assign pos_vsync = (~cam_vsync_d1) & cam_vsync_d0; 
	
	//֡Чź
	assign  cmos_frame_vsync = frame_val_flag  ?  cam_vsync_d1  :  1'b0; 
	
	//Чź
	assign  cmos_frame_href  = frame_val_flag  ?  cam_href_d1   :  1'b0; 
	
	//ʹЧź
	assign  cmos_frame_valid = frame_val_flag  ?  byte_flag_d0  :  1'b0; 
	
	//
	assign  cmos_frame_data  = frame_val_flag  ?  cmos_data_t   :  1'b0; 
	       
	always @(posedge cam_pclk or negedge rst_n) begin
	    if(!rst_n) begin
	        cam_vsync_d0 <= 1'b0;
	        cam_vsync_d1 <= 1'b0;
	        cam_href_d0 <= 1'b0;
	        cam_href_d1 <= 1'b0;
	    end
	    else begin
	        cam_vsync_d0 <= cam_vsync;
	        cam_vsync_d1 <= cam_vsync_d0;
	        cam_href_d0 <= cam_href;
	        cam_href_d1 <= cam_href_d0;
	    end
	end
	
	//֡м
	always @(posedge cam_pclk or negedge rst_n) begin
	    if(!rst_n)
	        cmos_ps_cnt <= 4'd0;
	    else if(pos_vsync && (cmos_ps_cnt < WAIT_FRAME))
	        cmos_ps_cnt <= cmos_ps_cnt + 4'd1;
	end
	
	//֡Ч־
	always @(posedge cam_pclk or negedge rst_n) begin
	    if(!rst_n)
	        frame_val_flag <= 1'b0;
	    else if((cmos_ps_cnt == WAIT_FRAME) && pos_vsync)
	        frame_val_flag <= 1'b1;
	    else;    
	end            
	
	//8λת16λRGB565        
	always @(posedge cam_pclk or negedge rst_n) begin
	    if(!rst_n) begin
	        cmos_data_t <= 16'd0;
	        cam_data_d0 <= 8'd0;
	        byte_flag <= 1'b0;
	    end
	    else if(cam_href) begin
	        byte_flag <= ~byte_flag;
	        cam_data_d0 <= cam_data;
	        if(byte_flag)
	            cmos_data_t <= {cam_data_d0,cam_data};
	        else;   
	    end
	    else begin
	        byte_flag <= 1'b0;
	        cam_data_d0 <= 8'b0;
	    end    
	end        
	
	//Чź(cmos_frame_valid)
	always @(posedge cam_pclk or negedge rst_n) begin
	    if(!rst_n)
	        byte_flag_d0 <= 1'b0;
	    else
	        byte_flag_d0 <= byte_flag;	
	end 
	       
	
endmodule    //coms_capture_data

