module inverse_arm(
	CLK_50M,
	RST_N,
	x0,
	y0,
	z0,
	inverse_en,
	ok,
	pwm_high_cnt1,
	pwm_high_cnt2,
	pwm_high_cnt3,
	pwm_high_cnt4,
	pwm_high_cnt5,
	pwm_high_cnt6);

	//---Ports declearation: generated by Robei---
	input CLK_50M;
	input RST_N;
	input [12:0] x0;
	input [12:0] y0;
	input [12:0] z0;
	input inverse_en;
	output ok;
	output [12:0] pwm_high_cnt1;
	output pwm_high_cnt2;
	output [12:0] pwm_high_cnt3;
	output [12:0] pwm_high_cnt4;
	output [12:0] pwm_high_cnt5;
	output [12:0] pwm_high_cnt6;

	wire CLK_50M;
	wire RST_N;
	wire [12:0] x0;
	wire [12:0] y0;
	wire [12:0] z0;
	wire inverse_en;
	reg ok;
	reg [12:0] pwm_high_cnt1;
	reg pwm_high_cnt2;
	reg [12:0] pwm_high_cnt3;
	reg [12:0] pwm_high_cnt4;
	reg [12:0] pwm_high_cnt5;
	reg [12:0] pwm_high_cnt6;

	//----Code starts here: integrated by Robei-----
	
	parameter       Alpha = 0;
	parameter       L0 = 900  ;               //setup_kinematics(90, 105, 98, 150, &kinematics);L0~L3且需要再来十?
	parameter       L1 = 1050 ;
	parameter       L2 = 980  ;
	parameter       L3 = 1500 ;
	parameter       pwm_total = 1_000_000;   				   //20ms
	parameter       pwm_high_initial = 75_000;              //1.5ms
	parameter       N = 32 ;
	reg             chenggong = 0;
	// reg [24:0]      pwm_int;
	reg signed [8:0]      theta1 ;
	reg signed [8:0]      theta2 ;
	reg signed [8:0]      theta3 ;
	reg signed [8:0]      theta4 ;
	reg signed [8:0]      theta5 ;
	reg signed [8:0]      theta6 ;
	reg 	signed	[31:0]     x1; 
	reg 	signed	[31:0]     y1;
	reg             start1;
	reg       [N-1:0]    num_in1;
	reg        [N-1:0]    num_in2;
	reg        signed [15:0]     yy ;//?	y = sqrt(x*x + y*y);//x y 斜边 
	reg        signed [31:0]     zz;//? z = z-l0-l3*sin(Alpha*pi/180.0); 
	wire            finished1;
	wire		[31:0] 		atan1;
	wire                     done1; 
	wire                     done2;
	wire        [N/2-1:0] sq_root1;
	wire   signed     [N/2-1:0] sq_root2;
	//wire        [7:0]       theta5_r;
	reg [31:0]          data1;
	reg                  kaishi;
	wire                 success;
	wire	 [31:0] 	 arccos1;
	reg  [31:0]         ccc;
	reg  [31:0]         bbb;
	reg  [31:0]         aaa;
	reg   [5:0]              a;
	reg                 b;
	reg                 c;
	reg [12:0] cnt_1; 
	reg [12:0] cnt_2;
	reg [12:0] cnt_3;
	reg [12:0] cnt_4;
	reg [12:0] cnt_5;
	/*assign  pwm1 = (pwm_high_cnt1 >= pwm_int) ? 1'b1 : 1'b0;
	assign  pwm2 = (pwm_high_cnt2 >= pwm_int) ? 1'b1 : 1'b0;
	assign  pwm3 = (pwm_high_cnt3 >= pwm_int) ? 1'b1 : 1'b0;
	assign  pwm4 = (pwm_high_cnt4 >= pwm_int) ? 1'b1 : 1'b0;
	assign  pwm5 = (pwm_high_cnt5 >= pwm_int) ? 1'b1 : 1'b0;
	assign  pwm6 = (pwm_high_cnt6 >= pwm_int) ? 1'b1 : 1'b0; */
	//assign  num_in1 = (x0 * x0) + (y0 * y0);
	//assign  phase1 = Alpha * 57;//y = y-l3 * cos(Alpha*pi/180.0);z = z-l0-l3*sin(Alpha*pi/180.0);但是此处得phase应该处于0~90?
	reg [24:0]     count;
	/* always@(posedge CLK_50M or negedge RST_N)begin
	    if(!RST_N)
	        pwm_int <= 25'd0;
	    else if(pwm_int == pwm_total - 25'd1)
	        pwm_int <= 25'd0;
	    else 
	        pwm_int <= pwm_int + 1'b1;       
	end    */     
	// assign theta5_r = ccc + arccos1;
	always@(posedge CLK_50M or negedge RST_N)begin
	    if(!RST_N)
	    begin
	        theta6 <= 0;
	        end
	        else
	        begin
	        if(inverse_en == 0)
	        theta6 = 0;
	            if(x0 == 0)
	                theta6 <= 0;
	            else
	            begin
	                start1 <= 1;
	                x1 <= y0;
	                y1 <= x0;
	                if(finished1 == 1'b1)
	                    theta6 <= atan1;
	                else
	                    theta6 <= theta6;
	            end
	        end
	
	end
	always@(posedge CLK_50M or negedge RST_N)begin
	    if(!RST_N)
	    begin
	        yy <= 0;
	        zz <= 0;
	        num_in2 <= 0;
	        end
	       else
	       begin
	       num_in1 = (x0 * x0) + (y0 * y0);
	            if(inverse_en == 0)
	            begin
	            yy <= 0;
	        zz <= 0;
	        num_in2 <= 0;
	        num_in1 <= 0;
	            end
	            if(sq_root1 != 0 )begin
	                yy <= sq_root1 - 1061  ;  // - 1061;  
	                zz <= z0 - L0  + 1061  ;  // + 1061;   
	                if(yy != 0 || zz != 0)
	                    begin
	                    
	                        num_in2 <= (yy * yy + zz * zz);
	                    end         
	                    else        
	                        num_in2 <= num_in2;
	                    
	            end
	            else
	            begin
	            yy <= yy;
	            zz <= zz;
	            end
	       end
	end
	always@(posedge CLK_50M or negedge RST_N)begin
	    if(!RST_N)
	    begin
	        a <= 0;
	        data1 <= 0;
	        bbb <= 0;
	        ccc <= 0;
	        theta3 <= 0;
	        theta4 <= 0;
	        theta5 <= 0;
	        cnt_1 <= 0;
	        cnt_2 <= 0;
	        cnt_3 <= 0;
	        cnt_4 <= 0;
	        cnt_5 <= 0;
	        kaishi <=0;
	        end 
	    else
	    begin
	    if(inverse_en == 0)begin
	             a <= 0;
	        data1 <= 0;
	        bbb <= 0;
	        ccc <= 0;
	        theta3 <= 0;
	        theta4 <= 0;
	        theta5 <= 0;
	        cnt_1 <= 0;
	        cnt_2 <= 0;
	        cnt_3 <= 0;
	        cnt_4 <= 0;
	        cnt_5 <= 0;
	        kaishi <=0;
	             end
	    
	    if(sq_root2 != 0 && a == 0)begin
	        a <= 1;
	    end
	    if(a == 1)begin
	    bbb <= 100*(yy * yy + zz * zz + L1 * L1 - L2 * L2) / (2 * L1 * sq_root2);
	    aaa <= 100*(yy * yy + zz * zz- L1 * L1 - L2 * L2)/(2 * L1 * L2);
	    data1 <= (100 * yy)/sq_root2 ;           /// sq_root2
	    kaishi <= 1;
	    if(success == 1)begin
	       cnt_1 <= cnt_1 + 1'd1;
	    if (cnt_1 == 5) begin                  //计数器，1ms变化??//if (cnt_1 == 500_000) begin 
	        cnt_1 <= 0;
	        ccc <= arccos1;//#2 
	        kaishi <= 0;    //#5
	        a <= 2;
	        end
	    end
	    end
	    if(a == 2)begin
	        kaishi <= 1;
	        data1 <= bbb;
	        if(success == 1)begin
	        cnt_2 <= cnt_2 + 1'd1;
	            if (cnt_2 >= 5) begin                  //计数器，1ms变化??//if (cnt_1 == 500_000) begin 
	            
	             theta5 <= ccc + arccos1;       //ccc +arccos1    //#2
	             a <= 3;
	            kaishi <= 0;
	            end
	        end
	    end
	    if(a == 3)begin
	        kaishi <= 1;
	        data1 <= aaa;
	        if(success == 1)begin
	        cnt_3 <= cnt_3 + 1'd1;
	            if (cnt_3 == 5) begin                  //计数器，1ms变化??//if (cnt_1 == 500_000) begin 
	            cnt_3 <= 0;
	           theta4 <= arccos1;//#2
	           a <= 4;           //#5
	           end
	        end
	    end
	    if(a == 4)
	    begin
	            cnt_4 <= cnt_4 + 1'd1;
	            if (cnt_4 == 5) begin                  //计数器，1ms变化??//if (cnt_1 == 500_000) begin 
	            cnt_4 <= 0;
	       theta3 <= -45 +theta4 - theta5;  //#2  
	         a <= 5;                   //#10
	         end
	    end
	   /*  else begin
	         theta3 <= theta3 ;
	         theta4 <= theta4 ;
	         theta5 <= theta5 ;
	    end */
	      end 
	        end       
	always@(posedge CLK_50M or negedge RST_N)begin
	    if(!RST_N)
	    begin
	        pwm_high_cnt1 <= 1500;
	        pwm_high_cnt2 <= 1500;
	        pwm_high_cnt3 <= 1500;
	        pwm_high_cnt4 <= 1500;
	        pwm_high_cnt5 <= 1500;
	        pwm_high_cnt6 <= 1500;
	        ok <= 0;
	        end
	        else
	        begin
	            if(a == 5 && inverse_en)
	                begin
	                ok <= 1;
	                pwm_high_cnt1 <= 1500-(2000 * theta6 / 270);
	                pwm_high_cnt2 <= 1500+(2000 * (theta5 - 90) / 270);
	                pwm_high_cnt3 <= 1500+(2000 * theta4 / 270);
	                pwm_high_cnt4 <= 1500-(2000 * theta3 / 270);
	                pwm_high_cnt5 <=  1500 ;
	                pwm_high_cnt6 <=  1500 ;
	                end
	            else
	            begin
	            pwm_high_cnt1 <= 1500;
	            pwm_high_cnt2 <= 1500;
	            pwm_high_cnt3 <= 1500;
	            pwm_high_cnt4 <= 1500;
	            pwm_high_cnt5 <= 1500;
	            pwm_high_cnt6 <= 1500;
	            end
	             if(inverse_en == 0)
	             ok <= 0;
	        end
	        
	end
	//---Module instantiation---
	square_root square_root1(
		.CLK_50M(CLK_50M),
		.RST_N(RST_N));

	square_root square_root2(
		.CLK_50M(CLK_50M),
		.RST_N(RST_N));

	Cordic_arccos1 Cordic_arccos14(
		.CLK_50M(CLK_50M),
		.RST_N(RST_N));

	Cordic_atan1 Cordic_atan14(
		.CLK_50M(CLK_50M),
		.RST_N(RST_N));

endmodule    //inverse_arm

