module lcd_display(
	lcd_pclk,
	rst_n,
	pixel_xpos,
	pixel_ypos,
	h_disp,
	v_disp,
	flag_hand,
	flag_size,
	what_color,
	flag_echo,
	x_com,
	y_com,
	check_flag,
	data_lin_cross,
	cross_flag,
	pixel_data);

	//---Ports declearation: generated by Robei---
	input lcd_pclk;
	input rst_n;
	input [10:0] pixel_xpos;
	input [10:0] pixel_ypos;
	input [10:0] h_disp;
	input [10:0] v_disp;
	input [2:0] flag_hand;
	input [2:0] flag_size;
	input [2:0] what_color;
	input [2:0] flag_echo;
	input [10:0] x_com;
	input [10:0] y_com;
	input check_flag;
	input [23:0] data_lin_cross;
	input cross_flag;
	output [23:0] pixel_data;

	wire lcd_pclk;
	wire rst_n;
	wire [10:0] pixel_xpos;
	wire [10:0] pixel_ypos;
	wire [10:0] h_disp;
	wire [10:0] v_disp;
	wire [2:0] flag_hand;
	wire [2:0] flag_size;
	wire [2:0] what_color;
	wire [2:0] flag_echo;
	wire [10:0] x_com;
	wire [10:0] y_com;
	wire check_flag;
	wire [23:0] data_lin_cross;
	wire cross_flag;
	reg [23:0] pixel_data;

	//----Code starts here: integrated by Robei-----
	
	//parameter define  
	parameter  BLACK		 =  24'h000000;	 //ɫ 
	parameter  BLUE			 =  24'h0000FF;	 //ɫ 
	parameter  GREEN		 =  24'h00FF00;  //ɫ
	parameter  RED			 =	24'hFF0000;  //ɫ
	parameter  WHITE         =  24'hFFFFFF;  //ɫ
	
	reg [23:0]  data_lin_size,data_lin_hand,data_lin_color,data_lin_echo,data_lin_cross_r;    //
	/*
	wire check_flag;        //Ŀλ
	
	assign check_flag = ((pixel_xpos >= x_com - 50 && pixel_xpos <= x_com + 50)&&
	                     (pixel_ypos >= y_com - 50 && pixel_ypos <= y_com + 50))? 1'b1:1'b0;
	*/
	always@ ( posedge lcd_pclk or negedge rst_n) begin		
	    if (!rst_n) begin
	    data_lin_size <= WHITE;
	    data_lin_hand <= WHITE;
	    data_lin_echo <= WHITE;
	    end
	    else begin
	//********Сж*********//
	    if (flag_size ==3'd0) begin			//size
			data_lin_size <= BLACK ;	
		end
		 if (flag_size ==3'd1) begin			//size
			data_lin_size <= RED ;	
		end	
		 if (flag_size ==3'd2) begin					//
			data_lin_size <= GREEN;
		end
		 if (flag_size ==3'd3) begin					//
			data_lin_size <= BLUE;
		end
	//************ж***********//
	    if (flag_hand ==3'd0) begin			//cnt_back==1
			data_lin_hand <= BLACK ;	
		end
		 if (flag_hand ==3'd1) begin			//cnt_back==1
			data_lin_hand <= RED ;	
		end	
		 if (flag_hand ==3'd2) begin			//cnt_back==2
			data_lin_hand <= GREEN;
		end
		 if ( flag_hand==3'd3) begin			//cnt_back==3
			data_lin_hand <= BLUE;
	//************************************//
	    if (flag_echo==3'd0) begin			//
			data_lin_echo <= BLACK ;	
		end	
		 if (flag_echo==3'd1) begin			//
			data_lin_echo <= RED ;	
		end	
		 if (flag_echo==3'd2) begin			
			data_lin_echo <= GREEN;
		end
		 if (flag_echo==3'd3) begin		
			data_lin_echo <= BLUE;	
		 end
		 if (flag_echo==3'd4) begin			
			data_lin_echo <= BLACK;	
		 end
		end	
		end
	end
	//****************************ɫʾ*************************************//
	always@ (posedge lcd_pclk or negedge rst_n) begin
	    if (!rst_n) begin
	        data_lin_color <= WHITE;
	    end
	    else begin
	        if (what_color == 3'd0) begin
	            data_lin_color <= BLACK;
	        end
	        if (what_color == 3'd1) begin
	            data_lin_color <= RED;
	        end
	        else if (what_color == 3'd2) begin
	            data_lin_color <= GREEN;
	        end 
	        else if (what_color == 3'd3) begin
	            data_lin_color <= BLUE;
	        end
	    /*    if(cross_flag) begin
	        data_lin_cross_r <= RED;
	        end
	        else begin
	        data_lin_cross_r <= BLUE;
	        end */
	    end
	end
	
	
	
	//ݵǰصָǰصɫݣĻʾ
	always @(posedge lcd_pclk or negedge rst_n) begin
	    if(!rst_n)
	        pixel_data <= BLACK;
	    else begin      //
	         if ((pixel_ypos >=11'd0)&&(pixel_ypos <= 11'd252)) begin       //ʾ⵽λ
	            pixel_data <= data_lin_cross;
	        end   
	       else if((pixel_xpos >= 11'd0) && (pixel_xpos < h_disp/5*1)&&((pixel_ypos>=11'd252)&&(pixel_ypos<=11'd272)))
	            pixel_data <= data_lin_echo;
	        else if((pixel_xpos >= h_disp/5*1) && (pixel_xpos < h_disp/5*2)&&((pixel_ypos>=11'd252)&&(pixel_ypos<=11'd272)))    
	            pixel_data <= data_lin_size;
	        else if((pixel_xpos >= h_disp/5*2) && (pixel_xpos < h_disp/5*3)&&((pixel_ypos>=11'd252)&&(pixel_ypos<=11'd272)))    
	            pixel_data <= data_lin_color;   
	        else if((pixel_xpos >= h_disp/5*3) && (pixel_xpos < h_disp/5*4)&&((pixel_ypos>=11'd252)&&(pixel_ypos<=11'd272)))    
	            pixel_data <= data_lin_hand;                   
	        else 
	            pixel_data <= BLACK;  
	            
	    end    
	end
	  
	
	
endmodule    //lcd_display

