module lcd_rgb_top(
	sys_clk,
	sys_rst_n,
	flag_hand,
	flag_size,
	what_color,
	flag_echo,
	x_com,
	y_com,
	cross_flag,
	lcd_de,
	lcd_hs,
	lcd_vs,
	lcd_bl,
	lcd_clk,
	lcd_rgb);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input [2:0] flag_hand;
	input [2:0] flag_size;
	input [2:0] what_color;
	input [2:0] flag_echo;
	input [10:0] x_com;
	input [10:0] y_com;
	input cross_flag;
	output lcd_de;
	output lcd_hs;
	output lcd_vs;
	output lcd_bl;
	output lcd_clk;
	inout [23:0] lcd_rgb;

	wire sys_clk;
	wire sys_rst_n;
	wire [2:0] flag_hand;
	wire [2:0] flag_size;
	wire [2:0] what_color;
	wire [2:0] flag_echo;
	wire [10:0] x_com;
	wire [10:0] y_com;
	wire cross_flag;
	wire lcd_de;
	wire lcd_hs;
	wire lcd_vs;
	wire lcd_bl;
	wire lcd_clk;
	wire [23:0] lcd_rgb;
	wire [15:0] rd_id4_lcd_id;
	wire [10:0] lcd_driver3_pixel_xpos;
	wire [10:0] lcd_driver3_pixel_ypos;
	wire [10:0] lcd_driver3_h_disp;
	wire [10:0] lcd_driver3_v_disp;
	wire lcd_driver3_check_flag;
	wire [23:0] lcd_driver3_data_lin_cross;
	wire [23:0] lcd_driver3_lcd_rgb;
	wire clk_div1_lcd_pclk;

	//----Code starts here: integrated by Robei-----
	
	//wire define    
	wire  [15:0]  lcd_id    ;    //LCDID
	wire              lcd_pclk;    //LCDʱ
	              
	wire  [10:0]  pixel_xpos;    //ǰص
	wire  [10:0]  pixel_ypos;    //ǰص
	wire  [10:0]  h_disp    ;    //LCDˮƽֱ
	wire  [10:0]  v_disp    ;    //LCDֱֱ
	wire  [23:0]  pixel_data;    //
	wire  [23:0]  lcd_rgb_o ;    //
	wire  [23:0]  lcd_rgb_i ;    //
	wire          check_flag;   //ʶʾı־
	wire  [23:0]  data_lin_cross;
	
	//*****************************************************//
	//* //                  main code
	//*****************************************************//
	
	//ݷл
	assign lcd_rgb = lcd_de ?  lcd_rgb_o :  {24{1'bz}};
	assign lcd_rgb_i = lcd_rgb;
	
	//LCD IDģ
	rd_id u_rd_id(
	    .clk          (sys_clk  ),
	    .rst_n        (sys_rst_n),
	    .lcd_rgb      (lcd_rgb_i),
	    .lcd_id       (lcd_id   )
	    );    
	
	//ʱӷƵģ    
	clk_div u_clk_div(
	    .clk           (sys_clk  ),
	    .rst_n         (sys_rst_n),
	    .lcd_id        (lcd_id   ),
	    .lcd_pclk      (lcd_pclk )
	    );    
	
	//LCDʾģ    
	lcd_display u_lcd_display(
	    .lcd_pclk       (lcd_pclk  ),
	    .rst_n          (sys_rst_n ),
	    .pixel_xpos     (pixel_xpos),
	    .pixel_ypos     (pixel_ypos),
	    .h_disp         (h_disp    ),
	    .v_disp         (v_disp    ),
	    .pixel_data     (pixel_data),
	    .flag_hand      (flag_hand ),
	    .flag_size      (flag_size ),
	    .what_color     (what_color),
	    .flag_echo      (flag_echo ),
	    .x_com          (x_com     ),
	    .y_com          (y_com     ),
	    .check_flag     (check_flag),
	    .data_lin_cross (data_lin_cross),
	    .cross_flag     (cross_flag)   
	    );    
	
	//LCDģ
	lcd_driver u_lcd_driver(
	    .lcd_pclk      (lcd_pclk  ),
	    .rst_n         (sys_rst_n ),
	    .lcd_id        (lcd_id    ),
	    .pixel_data    (pixel_data),
	    .pixel_xpos    (pixel_xpos),
	    .pixel_ypos    (pixel_ypos),
	    .h_disp        (h_disp    ),
	    .v_disp        (v_disp    ),
	
	    .lcd_de         (lcd_de    ),
	    .lcd_hs         (lcd_hs    ),
	    .lcd_vs         (lcd_vs    ),
	    .lcd_bl         (lcd_bl    ),
	    .lcd_clk        (lcd_clk   ),
	    .lcd_rgb        (lcd_rgb_o ),
	    .x_com          (x_com    ),
	    .y_com          (y_com    ),
	    .check_flag     (check_flag),
	    .data_lin_cross (data_lin_cross)
	    );
	
	
	
	//---Module instantiation---
	clk_div clk_div1(
		.clk(sys_clk),
		.rst_n(sys_rst_n),
		.lcd_id(rd_id4_lcd_id),
		.lcd_pclk(clk_div1_lcd_pclk));

	lcd_display lcd_display2(
		.lcd_pclk(sys_clk),
		.rst_n(sys_rst_n),
		.pixel_xpos(lcd_driver3_pixel_xpos),
		.pixel_ypos(lcd_driver3_pixel_ypos),
		.h_disp(lcd_driver3_h_disp),
		.v_disp(lcd_driver3_v_disp),
		.flag_hand(flag_hand),
		.flag_size(flag_size),
		.what_color(what_color),
		.flag_echo(flag_echo),
		.x_com(x_com),
		.y_com(y_com),
		.check_flag(lcd_driver3_check_flag),
		.data_lin_cross(lcd_driver3_data_lin_cross),
		.cross_flag(cross_flag),
		.pixel_data(lcd_rgb));

	lcd_driver lcd_driver3(
		.lcd_pclk(clk_div1_lcd_pclk),
		.rst_n(sys_rst_n),
		.lcd_id(rd_id4_lcd_id),
		.x_com(x_com),
		.y_com(x_com),
		.pixel_xpos(lcd_driver3_pixel_xpos),
		.pixel_ypos(lcd_driver3_pixel_ypos),
		.h_disp(lcd_driver3_h_disp),
		.v_disp(lcd_driver3_v_disp),
		.lcd_de(lcd_de),
		.lcd_hs(lcd_hs),
		.lcd_vs(lcd_vs),
		.lcd_bl(lcd_bl),
		.lcd_clk(lcd_clk),
		.lcd_rgb(lcd_driver3_lcd_rgb),
		.check_flag(lcd_driver3_check_flag),
		.data_lin_cross(lcd_driver3_data_lin_cross));

	rd_id rd_id4(
		.clk(sys_clk),
		.rst_n(sys_rst_n),
		.lcd_rgb(lcd_driver3_lcd_rgb),
		.lcd_id(rd_id4_lcd_id));

endmodule    //lcd_rgb_top

