module total_top(
	sys_clk,
	sys_rst_n,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	back_h,
	key1,
	key2,
	uart_rxd,
	uart_rxd_blue,
	cam_rst_n,
	cam_pwdn,
	cam_scl,
	start_flag,
	lcd_de,
	lcd_hs,
	lcd_vs,
	lcd_bl,
	lcd_clk,
	led1,
	led2,
	pwm_ud,
	pwm_head,
	pwm1,
	pwm2,
	pwm3,
	pwm4,
	pwm5,
	pwm6,
	uart_txd_f,
	uart_txd_b,
	lcd_rgb);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	input back_h;
	input key1;
	input key2;
	input uart_rxd;
	input uart_rxd_blue;
	output cam_rst_n;
	output cam_pwdn;
	output cam_scl;
	output start_flag;
	output lcd_de;
	output lcd_hs;
	output lcd_vs;
	output lcd_bl;
	output lcd_clk;
	output led1;
	output led2;
	output pwm_ud;
	output pwm_head;
	output pwm1;
	output pwm2;
	output pwm3;
	output pwm4;
	output pwm5;
	output pwm6;
	output uart_txd_f;
	output uart_txd_b;
	output [23:0] lcd_rgb;

	wire sys_clk;
	wire sys_rst_n;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	wire back_h;
	wire key1;
	wire key2;
	wire uart_rxd;
	wire uart_rxd_blue;
	wire cam_rst_n;
	wire cam_pwdn;
	wire cam_scl;
	wire start_flag;
	wire lcd_de;
	wire lcd_hs;
	wire lcd_vs;
	wire lcd_bl;
	wire lcd_clk;
	reg led1;
	reg led2;
	wire pwm_ud;
	wire pwm_head;
	wire pwm1;
	wire pwm2;
	wire pwm3;
	wire pwm4;
	wire pwm5;
	wire pwm6;
	wire uart_txd_f;
	wire uart_txd_b;
	wire [23:0] lcd_rgb;

	//----Code starts here: integrated by Robei-----
	
	//ͷź  
	wire    [2:0]      flag_hand        ;  //ź    
	wire    [2:0]      flag_size        ;  //ź  
	wire    [2:0]      what_color       ;  //ɫʶź     
	wire    [2:0]      flag_echo        ;  //ź    
	wire   [10:0]      x_com,y_com      ;  //Ŀ
	wire signed [12:0]      x_com_rr         ;
	wire signed [12:0] y_com_rr         ;
	wire   [10:0]      v_cnt            ;
	wire    [31:0]     y1               ;
	wire    [31:0]     y1_r             ;
	wire               led1_r           ;
	wire               led2_r           ;
	wire               kai              ;
	wire               ok               ;   //ִź
	
	reg signed [12:0]  x_com_r          ;
	reg signed [12:0]  y_com_r          ;
	reg  [31:0]       cnt_1m            ;
	
	assign x_com_rr = (5*x_com) - 2500-450 ;          //ϵ
	assign y_com_rr = 2500 - (5*y_com)-150 ;
	
	always @ (posedge sys_clk or negedge sys_rst_n) begin
	    if (!sys_rst_n)begin
	         x_com_r <= 0;
	         y_com_r <= 0;
	    end
	    else begin
	        if (cnt_1m >= 5000_0000) begin          //ʱ1mݸе
	            x_com_r <= x_com_rr;       //λ
	            y_com_r <= y_com_rr;
	        end
	        else begin  
	            cnt_1m <= cnt_1m + 1'd1;
	            x_com_r <= 0;
	            y_com_r <= 0;
	        end 
	    end
	end
	
	always@(posedge sys_clk) begin      //
	    if (kai) begin        //  x_com>=11'd1 && x_com <= 11'd480
	        led1<= 1'b1;
	    end
	    if (!kai) begin       //y_com >= 11'd1 && y_com <= 11'd272
	        led2 <= 1'b1;
	    end
	    if (!key1) begin
	        led1<= 1'b0;
	        led2<= 1'b0;
	    end
	end
	
	//*****************************Ӿ********************************//    
	//*****************************Ӿ********************************//  
	//*****************************Ӿ********************************//  
	view_top u_view_top (
	    .sys_clk                (sys_clk    ),
	    .sys_rst_n              (sys_rst_n  ),
	
	    .cam_pclk               (cam_pclk   ),
	    .cam_vsync              (cam_vsync  ),
	    .cam_href               (cam_href   ),
	    .cam_data               (cam_data   ),
	    .cam_rst_n              (cam_rst_n  ),
	    .cam_pwdn               (cam_pwdn   ),
	    .cam_scl                (cam_scl    ),
	    .cam_sda                (cam_sda    ),
	
	    .start_flag             (start_flag ),
	    .back_h                 (back_h     ),
	
	    .  lcd_de               (  lcd_de   ),
	    .  lcd_hs               (  lcd_hs   ),
	    .  lcd_vs               (  lcd_vs   ),
	    .  lcd_bl               (  lcd_bl   ),
	    .  lcd_clk              (  lcd_clk  ),
	    .  flag_hand            (flag_hand  ),
	    .  flag_size            (flag_size  ),
	    .  what_color           (what_color ),
	    .  flag_echo            (flag_echo  ),     
	    .  lcd_rgb              (  lcd_rgb  ),
	    .  x_com                (x_com      ),
	    .  y_com                (y_com      ),
	    .y1                     (y1)         ,
	    .y1_r                   (y1_r)       ,
	    .pwm_ud                 (pwm_ud)     ,
	    .pwm_head               (pwm_head)   ,
	    .key1                   (key1)       ,
	    .key2                   (key2)       ,
	    .kai                    (kai)
	);    
	
	//*****************************е۲********************************//    
	//*****************************е۲********************************//  
	//*****************************е۲********************************//    
	inverse_arm_all u_inverse_arm_all (
	     .sys_clk                   (sys_clk)   ,
	     .sys_rst_n                 (sys_rst_n) ,
	     .key1                      (key1)      ,
	     .key2                      (key2)      ,
	     .flag_hand                 (flag_hand) ,
	     .what_color                (what_color),
	     .flag_size                 (flag_size) ,
	     .ok_car                    (ok        ),
	     .x_com_r                   (x_com_r)   ,
	     .y_com_r                   (y_com_r)   ,
	     
	     .pwm1                      (pwm1)      ,
	     .pwm2                      (pwm2)      ,
	     .pwm3                      (pwm3)      ,
	     .pwm4                      (pwm4)      ,
	     .pwm5                      (pwm5)      ,
	     .pwm6                      (pwm6)      ,
	     .kai                       (kai )
	);    
	//****************************************Ʋ**************************************************//
	//****************************************Ʋ**************************************************//
	//****************************************Ʋ**************************************************//
	wheel_control u_wheel_control (
	    .sys_clk                   (sys_clk      ),
	    .sys_rst_n                 (sys_rst_n    ),
	    .uart_rxd                  (uart_rxd     ),
	    .key_forword               (kai       ),//kai
	    .key_back                  (key2_r       ),
		//.uart_rxd_blue			(uart_rxd_blue),
	    .key_left                  (             ),
	    .key_right                 (             ),
	    .led                       (led1_r       ),
	    .led2                      (led2_r       ),
	    .uart_txd_f                (uart_txd_f   ),
	    .uart_txd_b                (uart_txd_b   ),
	    .uart_rxd_blue             (uart_rxd_blue)
	);
	    
	
	
	//---Module instantiation---
	view_top view_top1(
		.sys_clk(sys_clk),
		.sys_rst_n(sys_rst_n),
		.cam_pclk(cam_pclk),
		.cam_vsync(cam_vsync),
		.cam_href(cam_href),
		.cam_data(cam_data),
		.back_h(back_h),
		.key1(key1),
		.key2(key2),
		.cam_rst_n(cam_rst_n),
		.cam_pwdn(cam_pwdn),
		.cam_scl(cam_scl),
		.start_flag(start_flag),
		.lcd_de(lcd_de),
		.lcd_hs(lcd_hs),
		.lcd_vs(lcd_vs),
		.lcd_bl(lcd_bl),
		.lcd_clk(lcd_clk),
		.pwm_ud(pwm_ud),
		.pwm_head(pwm_head),
		.lcd_rgb(lcd_rgb));

	wheel_control wheel_control3(
		.sys_clk(sys_clk),
		.sys_rst_n(sys_rst_n),
		.uart_rxd(uart_rxd),
		.uart_txd_f(uart_txd_f),
		.uart_txd_b(uart_txd_b),
		.uart_rxd_blue(uart_rxd_blue));

	inverse_arm_all inverse_arm_all3(
		.sys_clk(sys_clk),
		.sys_rst_n(sys_rst_n),
		.pwm1(pwm1),
		.pwm2(pwm2),
		.pwm3(pwm3),
		.pwm4(pwm4),
		.pwm5(pwm5),
		.pwm6(pwm6));

endmodule    //total_top

