module wheel_control(
	sys_clk,
	sys_rst_n,
	uart_rxd,
	key_forword,
	key_back,
	key_left,
	key_right,
	led,
	led2,
	uart_txd_f,
	uart_txd_b,
	uart_rxd_blue);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input uart_rxd;
	input key_forword;
	input key_back;
	input key_left;
	input key_right;
	output led;
	output led2;
	output uart_txd_f;
	output uart_txd_b;
	input uart_rxd_blue;

	wire sys_clk;
	wire sys_rst_n;
	wire uart_rxd;
	wire key_forword;
	wire key_back;
	wire key_left;
	wire key_right;
	reg led;
	reg led2;
	wire uart_txd_f;
	wire uart_txd_b;
	wire uart_rxd_blue;

	//----Code starts here: integrated by Robei-----
	
	reg signed [15:0] control_x1;
	reg signed [15:0] control_x2;//reg define
	reg       run;
	reg       kai;
	reg        usart_down;
	reg        uart_en_d0; 
	reg        uart_en_d1;  
	reg [15:0] clk_cnt;                         //ϵͳʱӼ
	reg [3:0]  tx_cnt;                          //ݼ
	reg        tx_flag;                         //͹̱־ź'b
	reg [7:0]  tx_data_f;                       //ǰ
	reg [7:0]  tx_data_b;                       //
	reg        first;
	reg [3:0]  state;
	wire       en_flag;
	reg [3:0]  a1;                              //ȡλ
	reg [3:0]  b1;
	reg [3:0]  c1;
	reg [3:0]  d1;
	reg [3:0]  a2;
	reg [3:0]  b2;
	reg [3:0]  c2;
	reg [3:0]  d2;
	reg [3:0]  a3;
	reg [3:0]  b3;
	reg [3:0]  c3;
	reg [3:0]  d3;
	reg [3:0]  a4;
	reg [3:0]  c4;
	reg [3:0]  b4;
	reg [3:0]  d4;
	reg signed [15:0] x1;
	reg signed [15:0] y1;
	reg signed [15:0] x2;
	reg signed [15:0] y2;
	reg [15:0] Kp = 16'd1; // ϵ
	reg [15:0] Ki = 8; // ϵ
	reg [15:0] Kd = 16; // ΢ϵ
	reg signed [15:0] tempx;//x
	reg signed [15:0] tempy;//y
	//reg [31:0] temptan;  //yxб//ʱҪ
	parameter k =4'd2;  //б
	reg [31:0] tempd;//d
	reg signed [15:0] errorx1;//һx
	//reg1531:0] y1;//һy//ʱҪ
	reg signed [15:0] errorx2;//x
	//reg [31:0] y2;//y//ʱҪ
	//reg [31:0] motor_right;
	//reg [31:0] motor_left;
	reg lockout;
	reg [15:0] integral_x1;
	reg [15:0] integral_x2;
	reg [15:0] derivative_x1;
	reg [15:0] derivative_x2;
	reg [15:0] preverrorx1;
	reg [15:0] preverrorx2;
	reg [15:0] tempx1;
	reg [15:0] tempy1;
	reg [1:0]  cnt;
	reg        clk_8;
	reg        stop;
	//rg [31:0] start;
	wire [15:0]  x;
	wire [15:0]  y;
	wire [15:0]  z;
	wire        data_analysis;
	wire [15:0]  subtag;
	wire rx_done;
	wire dataout;
	reg    [15:0]    mubiaox;
	reg    [15:0]    mubiaoy;
	parameter  dt = 100; // ʱ
	parameter  signed max_control=16'd750;
	parameter  signed min_control=16'd0;
	parameter  signed max_integral=16'd1000;
	parameter  signed min_integral=-16'd1000;
	reg level1;
	reg level2;
	reg [25:0]cnt1;
	parameter T=50000000;
	reg on;
	
	
		
	always@(posedge sys_clk)begin
	if(data_analysis)begin
	    led=1'b1;
	end else begin
	led=1'b0;
	end
	
	
	end
	
	always@(posedge sys_clk )begin
		if(!sys_rst_n)
			cnt1 <= 26'd0;			//λ
		else begin
		if	(!key_forword)begin		//0ʼҪ -1
			cnt1 <= 26'd0;	
		 if (cnt1<=T )begin		//0ʼҪ -1
		control_x1<= 16'd750;
		control_x2<= 16'd750;
			cnt1 <= cnt1 + 2'd1; 		//ûһֱ
		end else if(cnt1>=T  &&cnt1<=2*T)begin
		control_x1<=16'd750;
		control_x2<=-16'd750;
			cnt1 <= cnt1 + 2'd1; 	
		 end else
	      cnt1 <= 2'd0;			//	
	      control_x1<=16'd0;
		control_x2<= 16'd0;
	      end
	      end
	end
	
	always@(posedge sys_clk or negedge sys_rst_n)begin
		if(!sys_rst_n)
			cnt <= 2'd0;			//λ
		else if(cnt == 2'd3)		//0ʼҪ -1
			cnt <= 2'd0;			//
		else
			cnt <= cnt + 2'd1; 		//ûһֱ
	end
	 
	//8Ƶʱģ
	//8Ƶʱӽзת
	//8Ƶʱÿ4ڷתһΣ8ƵڼΪ8ʱ
	always@(posedge sys_clk or negedge sys_rst_n)begin
		if(!sys_rst_n)                  
			clk_8 <= 1'b0;          //λ
		else if(cnt == 2'd2)  		//4ʱ
			clk_8 <= ~clk_8;        //ת
		else                            
			clk_8 <= clk_8; 		//ûͱԭ״̬
	end
	
	
	
	
	
	//---Module instantiation---
	imusoliddataselect imusoliddataselect1(
		.sys_clk(sys_clk),
		.sys_rst_n(sys_rst_n),
		.uart_txd_f(uart_txd_f),
		.uart_txd_b(uart_txd_b));

endmodule    //wheel_control

