module color_if(
	sys_clk,
	sys_rst_n,
	pre_frame_de,
	car_move_flag,
	img_y,
	img_cb,
	img_cr,
	cross_flag,
	what_color,
	x_com,
	y_com,
	flag_size,
	y1,
	y1_r);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input pre_frame_de;
	input car_move_flag;
	input [7:0] img_y;
	input [7:0] img_cb;
	input [7:0] img_cr;
	output cross_flag;
	output [2:0] what_color;
	output [10:0] x_com;
	output [10:0] y_com;
	output [2:0] flag_size;
	output [31:0] y1;
	output [31:0] y1_r;

	wire sys_clk;
	wire sys_rst_n;
	wire pre_frame_de;
	wire car_move_flag;
	wire [7:0] img_y;
	wire [7:0] img_cb;
	wire [7:0] img_cr;
	reg cross_flag;
	reg [2:0] what_color;
	reg [10:0] x_com;
	reg [10:0] y_com;
	reg [2:0] flag_size;
	reg [31:0] y1;
	reg [31:0] y1_r;

	//----Code starts here: integrated by Robei-----
	
	
	
	parameter  H_LINE		 =  32'd480;    //像素点坐标加??
	parameter  v_LINE		 =  11'd272;
	parameter  H_SYNC_4342   =  11'd41;     //行同?
	parameter  H_BACK_4342   =  11'd2;      //行显示后?
	parameter  H_DISP_4342   =  11'd480;    //行有效数?
	parameter  H_FRONT_4342  =  11'd2;      //行显示前?
	parameter  H_TOTAL_4342  =  11'd525;    //行扫描周?
	
	parameter  V_SYNC_4342   =  11'd10;     //场同?
	parameter  V_BACK_4342   =  11'd2;      //场显示后?
	parameter  V_DISP_4342   =  11'd272;    //场有效数?
	parameter  V_FRONT_4342  =  11'd2;      //场显示前?
	parameter  V_TOTAL_4342  =  11'd286;    //场扫描周?
	
	parameter  BLACK		 =  16'h0000;	 //准心颜色，黑? 
	parameter  BLUE			 =  16'h0018;	 //准心颜色，蓝? 
	parameter  GREEN		 =  16'h0400;
	parameter  RED			 =	16'hfb08;
	parameter  WHITE         =  16'hffff;
	
	reg [31:0] cnt_pixel_r,cnt_pixel_b;
	//reg	[15:0] cross_b;	//
	//reg	[15:0] cross_a;	//
	reg	[31:0] x0,y0,x1,x0_b,x1_b,x0_r,x1_r,y1_b;       //y1 y1_r
	reg	[31:0] cnt,cnt_1ms        ;
	reg	[31:0] t_cnt;	//行场计数    
	reg [10:0] h_cnt ,v_cnt       ;
	reg	       cnt_flag,delay_1ms ;
	reg   [2:0]	 size_b,size_r    ;
	reg   [2:0] what_color_r      ;
	reg   [10:0]  x_com_rr,y_com_rr;       //x_com_r,y_com_r ,
	reg   [2:0] flag_size_r       ;
	reg         tw_cnt            ;     //֡
	wire [10:0] x_com_r,y_com_r   ;
	
	assign   x_com_r = y1%480     ;
	assign   y_com_r = y1/480     ;
	
	always@ (posedge sys_clk ) begin
	    if (cnt >= 50) begin
	        cnt <= 32'd0;
	        cnt_flag <= 1'b1;
	    end
	    else begin
	cross_flag <= 0;
	        cnt <= cnt + 32'd1;
	        cnt_flag <= 1'b0;
	    if (cnt_1ms >= 1000000) begin
	        delay_1ms <= 1'b1;
	        cnt_1ms <= 32'd0;       
	    end
	    else begin
	        cnt_1ms <= + cnt_1ms + 1'd1;
	        delay_1ms <= 1'b0;
	    end
	    end
	end	
	
	//****************************************ɫ***************************************************//
	always@ (posedge sys_clk or negedge sys_rst_n) begin
		if(!sys_rst_n) begin			
			cnt_pixel_r <= 0;		
		end
		else begin						// t_cnt >= 65040 && t_cnt <= 65520			水平中线 
		if(img_cr >= 173) begin		//红色识别	  175
					cnt_pixel_r <=  cnt_pixel_r + 32'd1 ;	
			if (cnt_pixel_r >= 2000 ) begin           //
					size_r <= 3'd3;                 
			end 
			if (cnt_pixel_r >= 1200 && cnt_pixel_r <= 1600) begin      //
					size_r <= 3'd2;
			end 	
			if (cnt_pixel_r <= 1000 ) begin        //С
					size_r <= 3'd1;			
			end
			end		
		if (t_cnt == 130559) begin
			cnt_pixel_r <= 0;		
		end 
		end
	end
	//********************************************************************************************//
	always @ (posedge sys_clk or negedge sys_rst_n) begin
	    if (!sys_rst_n) begin
	        x0_r <= 0 ;
	        x1_r <= 0 ;
	        y1_r <= 0 ;
	        x0_b <= 0 ;
	        x1_b <= 0 ;
	        y1_b <= 0 ;
	    end
	    else begin
	        if (img_cr >= 173) begin
	            x0_r <=  t_cnt  ;     //x0_r +
	              //  y1_r <= (x0_r)/2  ;
	        end
	        else if (img_cb >=173)begin
	            x0_b <=  t_cnt  ;     //x0_b +
	              //  y1_b <= (x0_b)/2  ;   
	        end
	    /*      if (t_cnt == 130559) begin
	              x0_r <= 0 ;
	              x1_r <= 0 ;
	              //y1_r <= 0 ;
	              x0_b <= 0 ;
	              x1_b <= 0 ;
	              //y1_b <= 0 ;
	         end    */
	    end
	end
	//****************************************ɫ***************************************************//
	always@ (posedge sys_clk or negedge sys_rst_n) begin
		if(!sys_rst_n) begin			
			cnt_pixel_b <= 0;
		end
		else begin					
		if(img_cb >= 173) begin		//红色识别	
					cnt_pixel_b <=  cnt_pixel_b + 32'd1 ;	
			if (cnt_pixel_b >= 2000 ) begin           //
					size_b <= 3'd3;                 
			end 
			if (cnt_pixel_b >= 1200 && cnt_pixel_b <= 1600) begin      //
					size_b <= 3'd2;
			end 	
			if (cnt_pixel_b <= 1000 ) begin        //С
					size_b <= 3'd1;			
			end
			end		
		if (t_cnt == 130559) begin
			cnt_pixel_b <= 0;		
		end 
		end
	end
	//******************************************ѡ*****************************************************//
	always @ (posedge sys_clk or negedge sys_rst_n) begin
	if (!sys_rst_n) begin
	    what_color_r <= 0;
	    flag_size_r  <=0 ;
	    y1           <=0 ;
	end
	    else begin
	        if (cnt_pixel_b >= cnt_pixel_r && t_cnt==130558) begin      //ɫϢ
	            what_color_r <= 3'd3;
	            flag_size_r <= size_b;
	            y1 <= x0_b;         //   y1_b   
	        end
	       else  if (cnt_pixel_b <= cnt_pixel_r && t_cnt==130558)begin      //ɫϢ
	            what_color_r <= 3'd1;
	            flag_size_r <= size_r;
	            y1 <= x0_r;         //y1_r
	        end
	    /*    else if (cnt_pixel_b <= 1000 && cnt_pixel_r <= 1000 && t_cnt == 130558)begin      //Ϣ
	            what_color_r <= 3'd0;
	            flag_size_r  <= 0;
	            y1 <= 0;
	        end  */
	    end
	end
	
	//********************************************ȶˢ***************************************************************//
	always @ (posedge sys_clk or negedge sys_rst_n) begin    //delay_1ms
	      if (!sys_rst_n) begin
	        what_color <= 0;
	        flag_size  <= 0;
	        x_com      <= 0;
	        y_com      <= 0;
	      end
	 else begin  
	    if (t_cnt == 130559) begin         //
	         what_color	  <= what_color_r ;
	         flag_size    <= flag_size_r  ;
	   end                
	   else begin         
	         what_color	  <= what_color ;
	         flag_size    <= flag_size  ;
	   end
	        if (/*(x_com_r >1 && x_com_r <480) && (y_com_r >1 && y_com_r <272) */1 ) begin
	                x_com <= x_com_r ;           //x_com_r
	                y_com <= y_com_r ;           //y_com_r  
	        end
	        else if (delay_1ms) begin
	             x_com <= x_com ;           //x_com_r
	             y_com <= y_com ;
	        end
	    end
	end	
	//****************************************һ֡ص***************************************************//
		always@ (posedge sys_clk or negedge sys_rst_n) begin
		if(!sys_rst_n) begin
		   t_cnt <= 32'd0;
		   tw_cnt <= 1'b0;
		end
		else if(pre_frame_de)begin     //
		if(t_cnt == 130560-1)begin 		   //标准?帧的像素点个数！！！！！
		   t_cnt <= 32'd0;			 
		   tw_cnt <= ~tw_cnt;
		end
		else
		t_cnt <= t_cnt + 1'd1;           
	end
	end
	
	
	//行计数器对像素时钟计?
	always@ (posedge sys_clk or negedge sys_rst_n) begin
	    if(!sys_rst_n) 
	        h_cnt <= 11'd0;
	    else if(pre_frame_de)begin       //||1
	        if(h_cnt >= 11'd480-1) 			//
	            h_cnt <= 11'd0;			
	        else
	            h_cnt <= h_cnt + 1'd1;           
	    end
	    else begin
	        h_cnt <= 0;
	    end
	end
	
	//场计数器对行计数
	always@ (posedge sys_clk or negedge sys_rst_n) begin
	    if(!sys_rst_n) 
	        v_cnt <= 11'd0;
	    else if(pre_frame_de)begin       //||1       
	        if(h_cnt >= 11'd480-1) begin		//
	            if(v_cnt >= 11'd272-1) 
	                v_cnt <= 11'd0;					
	            else
	                v_cnt <= v_cnt + 1'd1;    
	       end
	       else begin
	            v_cnt <= 0;
	       end
	    end    
	end
	
	
endmodule    //color_if

